"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
// tsc src/Req.ts --declaration & bundle-cli src/Req.ts dist/Req.min.js -b -name=Req -u -udd -udc
var LayerMsg = self.LayerMsg || null;
function find(predicate, thisArg) {
    var arr = thisArg || this;
    // if (!isArrayLike(arr)) throw new TypeError();
    // if (!isFunction(predicate)) return; // 在typescript中有类型检查，不需要这一句
    var len = arr.length;
    for (var i = 0; i < len; i++) {
        var item = arr[i];
        if (predicate(item, i, arr))
            return item;
    }
}
function isNaN(target) {
    // return String(target) === "NaN"; // "NaN" 会被判断为true
    return "number" === typeof target && target !== target;
}
// includes(searchElement: T, fromIndex?: number): boolean
function includes(thisArg, searchElement, fromIndex) {
    if (fromIndex === void 0) { fromIndex = 0; }
    var arr = thisArg || this;
    // if (!isArrayLike(arr)) throw new TypeError();
    var len = arr.length;
    for (var i = fromIndex; i < len; i++) {
        var item = arr[i];
        if (typeof searchElement === "function") {
            if (searchElement(item, i, arr))
                return true;
        }
        else {
            if (item === searchElement)
                return true;
        }
        if (isNaN(item) && isNaN(searchElement))
            return true;
    }
    return false;
}
var Req = /** @class */ (function () {
    function Req(config, jqAjaxConfig, codeResolve) {
        var _this = this;
        if (config === void 0) { config = { baseUrl: "" }; }
        if (jqAjaxConfig === void 0) { jqAjaxConfig = {}; }
        if (codeResolve === void 0) { codeResolve = [
            {
                codes: [200],
                resolve: function (res) {
                    return Promise.resolve(res);
                }
            }
        ]; }
        this.config = config;
        this.jqAjaxConfig = jqAjaxConfig;
        this.codeResolve = codeResolve;
        this.ajaxList = [];
        this.request = function (method, url, data, jqAjaxConfig) {
            if (data === void 0) { data = {}; }
            if (jqAjaxConfig === void 0) { jqAjaxConfig = _this.jqAjaxConfig; }
            var _a = _this, codeResolve = _a.codeResolve, _b = _a.config.baseUrl, baseUrl = _b === void 0 ? "" : _b;
            var onSuccess = jqAjaxConfig.success;
            delete jqAjaxConfig.success;
            var onError = jqAjaxConfig.error;
            delete jqAjaxConfig.success;
            var ajax;
            var promise = new Promise(function (resolve, reject) {
                var successCB = function (res) {
                    onSuccess && onSuccess(res);
                    resolve(res);
                };
                var errorCB = function (e) {
                    onError && onError(e);
                    reject(e);
                };
                var param = {
                    dataType: "json",
                    timeout: 10000,
                    success: function (res) {
                        var _a;
                        var code = Number((_a = res.code) !== null && _a !== void 0 ? _a : res.status);
                        if (!codeResolve || !codeResolve.length) {
                            successCB(res);
                            return;
                        }
                        var item = find(function (item) {
                            return includes(item.codes, code);
                        }, codeResolve);
                        if (item) {
                            item.resolve(res).then(successCB, errorCB);
                            return;
                        }
                        LayerMsg === null || LayerMsg === void 0 ? void 0 : LayerMsg.error(res.msg || res.message);
                        errorCB(res);
                    },
                    error: function (e) {
                        if (e.statusText !== "abort") {
                            LayerMsg === null || LayerMsg === void 0 ? void 0 : LayerMsg.error("网络错误，请检查网络后重试");
                        }
                        errorCB(e);
                    }
                };
                _this.ajax = ajax = $.ajax(__assign(__assign(__assign({}, param), jqAjaxConfig), {
                    url: baseUrl + url,
                    type: method,
                    data: data
                }));
                _this.ajaxList.push(ajax);
            });
            promise["finally"](function () {
                var index = _this.ajaxList.indexOf(ajax);
                if (index > -1) {
                    _this.ajaxList.splice(index, 1);
                }
            });
            return promise;
        };
        this.sync = {
            get: function (url, data, onSuccess, onError) {
                if (data === void 0) { data = {}; }
                var params = __assign(__assign({}, _this.jqAjaxConfig), {
                    async: false,
                    success: function (res) {
                        onSuccess && onSuccess(res);
                    },
                    error: function (e) {
                        onError && onError(e);
                    }
                });
                return _this.request("get", url, data, params);
            },
            post: function (url, data, onSuccess, onError) {
                if (data === void 0) { data = {}; }
                var params = __assign(__assign({}, _this.jqAjaxConfig), {
                    async: false,
                    success: function (res) {
                        onSuccess && onSuccess(res);
                    },
                    error: function (e) {
                        onError && onError(e);
                    }
                });
                return _this.request("post", url, data, params);
            }
        };
        this.get = function (url, data) {
            if (data === void 0) { data = {}; }
            return _this.request("get", url, data);
        };
        this.post = function (url, data) {
            if (data === void 0) { data = {}; }
            return _this.request("post", url, data);
        };
        this.abort = function () {
            _this.ajaxList.forEach(function (aj) {
                aj.abort();
            });
            _this.ajaxList = [];
        };
    }
    Req["default"] = new Req();
    Req.sync = Req["default"].sync;
    Req.get = Req["default"].get;
    Req.post = Req["default"].post;
    return Req;
}());
exports["default"] = Req;
